
#include "common.h"

/*
 * ===================================
 * Return process elapsed time
 * ===================================
 */
__int64 PB_GetTimeProcess( long resolution )
{
	unsigned __int64 currentTime;

	QueryPerformanceCounter( (LARGE_INTEGER*)&currentTime );

	currentTime = currentTime - startTime_g;

	switch ( resolution ) 
	{
	case PB_TIME_SECOND :
		return currentTime / rawFrequency_g;
		break;
	case PB_TIME_DECISECOND :
		return currentTime / dsFrequency_g;
		break;
	case PB_TIME_CENTISECOND :
		return currentTime / csFrequency_g;
		break;
	case PB_TIME_MILLISECOND :
		return currentTime / msFrequency_g;
		break;
	case PB_TIME_MICROSECOND :
		return currentTime / usFrequency_g;
		break;
	case PB_TIME_NANOSECOND :
		return currentTime / nsFrequency_g;
		break;
	}

	return 0;
}