
#include "common.h"

/*
 * ===================================
 * Set the interval time
 * ===================================
 */
void PB_TimerSetInterval( integer TimerID, integer time, long resolution )
{
	PB_Timer *Timer;
	unsigned __int64 currentTime;
	unsigned __int64 ticks;

	QueryPerformanceCounter( (LARGE_INTEGER*)&currentTime );

	if ( Timer = PB_Timer_GetObject( TimerID ) ) {
		Timer->timeInterval	= time;
		Timer->resolution	= resolution;
		Timer->status		= PB_TIMERSTATUS_WAIT;

		switch ( resolution ) 
		{
		case PB_TIME_SECOND :
			ticks = time * rawFrequency_g;
			break;
		case PB_TIME_DECISECOND :
			ticks = time * dsFrequency_g;
			break;
		case PB_TIME_CENTISECOND :
			ticks = time * csFrequency_g;
			break;
		case PB_TIME_MILLISECOND :
			ticks = time * msFrequency_g;
			break;
		case PB_TIME_MICROSECOND :
			ticks = time * usFrequency_g;
			break;
		case PB_TIME_NANOSECOND :
			ticks = time * nsFrequency_g;
			break;
		}

		Timer->intervalTicks = ticks;
		Timer->timeOut = currentTime + ticks;
	}
}
